package com.iformall.controller.market;

import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxGameTemplate;
import com.iformall.service.WxGameTemplateService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("wxGameTemplate")
@Api(description = "游戏模板接口")
public class WxGameTemplateController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxGameTemplateService wxGameTemplateService;

    @ApiOperation("分页列表接口")
    @GetMapping("listPage")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "游戏模板-分页列表")
    public ResultData listPage(@ModelAttribute WxGameTemplate wxGameTemplate, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxGameTemplateController::listPage");
        if (null == wxGameTemplate) wxGameTemplate = new WxGameTemplate();
        final PageInfo<WxGameTemplate> page = wxGameTemplateService.listAsPage(wxGameTemplate, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("列表接口")
    @GetMapping("list")
    @SystemControllerLog(description = "游戏模板-列表")
    public ResultData list(@ModelAttribute WxGameTemplate wxGameTemplate) {
        logger.debug("[" + getIpAddr() + "] WxGameTemplateController::list");
        if (null == wxGameTemplate) wxGameTemplate = new WxGameTemplate();
        final List<WxGameTemplate> page = wxGameTemplateService.getList(wxGameTemplate);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "游戏模板-新增")
    public ResultData add(@RequestBody WxGameTemplate wxGameTemplate) {
        logger.debug("[" + getIpAddr() + "] WxGameTemplateController::add");
        //Assert.notNull(wxGameTemplate.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxGameTemplateService.saveOrUpdate(wxGameTemplate);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "游戏模板-更新")
    public ResultData update(@RequestBody WxGameTemplate wxGameTemplate) {
        logger.debug("[" + getIpAddr() + "] WxGameTemplateController::update");
        wxGameTemplateService.saveOrUpdate(wxGameTemplate);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "游戏模板-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxGameTemplateController::delete");
        wxGameTemplateService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "游戏模板-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxGameTemplateController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxGameTemplateService.getById(id));
    }


}
